import java.util.Collection;

import javax.persistence.EntityManager;
import javax.persistence.Query;

public class ProfessorService {
  protected EntityManager em;

  public ProfessorService(EntityManager em) {
    this.em = em;
  }

  public Professor createProfessor(String name, long salary) {
    Professor emp = new Professor();
    emp.setName(name);
    emp.setSalary(salary);
    em.persist(emp);

    return emp;
  }

  public Professor addProfessorPhone(int empId, int phoneId) {
    Professor emp = em.find(Professor.class, empId);
    Phone phone = em.find(Phone.class, phoneId);
    emp.addPhone(phone);
    return emp;
  }

  public Collection<Professor> findAllProfessors() {
    Query query = em.createQuery("SELECT e FROM Professor e");
    return (Collection<Professor>) query.getResultList();
  }

  public Phone createPhone(String num, String type) {
    Phone phone = new Phone();
    phone.setNumber(num);
    phone.setType(type);
    em.persist(phone);

    return phone;
  }

  public Collection<Phone> findAllPhones() {
    Query query = em.createQuery("SELECT p FROM Phone p");
    return (Collection<Phone>) query.getResultList();
  }
}
